#include "actor.h"
#include "game.h"
#include "intro.h"
#include "map.h"
#include "player.h"
#include "sdk/hardware.h"
#include "sdk/joypad.h"
#include "sdk/oam.h"
#include "sdk/video.h"
#include "vram.h"

void level(void) {
    lcd_disable();

    map_load(&map_intro);
    player_init();
    actor_init();

    lcd_enable();

    while (1) {
        joypad_update();
        player_update();
        actor_update();

        HALT();
        rIF = 0;

        vram_update();
        oam_dma_copy();
    }
}
